function [ures] = HSTdnTouch_RBFFD(tol)

Nx = max(20,round((log10(tol)+1.1082e+00)/(-9.6392e-03)));

%% Setup
p = 2;
d = 5;
nm = 3;

dim = 2; %problem dimension

m = nchoosek(p+dim, p); %number of polynomial terms;
n = round(nm*m);

% Nx = 20;
M = 100;

x_max = 4;
y_max = 2;

%% Model
tic
%%% HST
alpha = 0;
beta = 1;
gamma = 0;

fmod = @(x) 0.5*alpha*x.^2 + beta*x + gamma;

% %parset
T = 1;
r = 0.00;
kappa = 2.58;
eta = 0.043;
sig = 1;
rho = -0.36;

% S0 = [75,100,125];
% sig0 = 0.114;

L = 50;
U = 150;

%% Grid
xscale = U/x_max;


Umul = 1;

x_min = L/xscale;
% x_max = 20;

Lx = L/xscale;
Ux = U/xscale;
% Nx = 200


y_min = 0.001;
Ny = round(Nx*((y_max-y_min)/x_max));

x = transpose(linspace(x_min,x_max,Nx));
y = transpose(linspace(y_min,y_max,Ny));
% y = y(2:end); Ny = Ny - 1;
dx = x(2)-x(1);
dy = y(2)-y(1);

% y_min = 0.001;
% y_max = 4;
% Ny = round(Nx*((y_max-y_min)/x_max));
% c = y_max/1.5;
% i = 0:Ny;
% dyi = (1/Ny)*asinh(y_max/c);
% yi = i*dyi;
% y = c*sinh(yi);
% y = y(2:end);

[X,Y] = meshgrid(x,y);

xvec = X(:);
yvec = Y(:);

N = numel(xvec);

ind = 1:N;
indcf = 1:Ny;
% indcf = 1;
indff = (N-Ny+1):N; %, Ny:Ny:N-Ny];
indin = ind; 
indup = Ny:Ny:N;
inddo = 1:Ny:N;

% inddy0 = [indup, inddo];
inddy0 = indup(2:end-1);

indin([indff,indcf]) = [];

% M = 100;

dt=T/(M-1);

%% Initial condition
u0 = ((xvec>Lx) & (xvec<Ux));
u=u0;

%% RBF
phi='phs';
s = [xvec yvec];

parallel = 1;
W = QLSVweights2Drbffd(r,rho,sig,alpha,beta,gamma,kappa,eta,xscale,s,N,n,m,p,indin,inddy0,phi,d,'reg',parallel);
% W = QLSVweights2Drbffdsp(r,rho,sig,alpha,beta,gamma,kappa,eta,xyscale,s,N,n,m,p,indin,inddy0,phi,d,'reg',parallel);
I = speye(size(W));

%% Integration
% [u,xvec,yvec] = HSTdnTouchintegrate(u,I,T,M,W,xscale,xvec,yvec,dx,dy,indin,indff,inddy0,r,'backslash');
%% Integration
% BDF-1
u1 = u;
A = I-dt*W;

b = u1;
% b(inddy0) = 2*u(inddy0-1) - u(inddy0-2);

u = A\b;
u = max(u,zeros(size(u)));

% BDF-2
A = I-(2/3)*dt*W;
rcm = symrcm(A);
A = A(rcm,rcm);
[L1, U1] = lu(A);
for ii = 3:M
    u2 = u1;
    u1 = u;
    b = (4/3)*u1-(1/3)*u2;
%     b(inddy0) = 2*u(inddy0-1) - u(inddy0-2);

    u(rcm) = L1\b(rcm);
    u(rcm) = U1\u(rcm);

    u = max(u,zeros(size(u)));
   
end
xvec = xscale*xvec;
% u = xscale*u;
%% Result

xres = [75,100,125];
yres = [0.114,0.114,0.114];

ures = griddata(xvec,yvec,u,xres,yres,'cubic');
end