function [ures] = HSTeuCall_RBFFD(tol)

Nx = max(20,round((log10(tol)+1.063473638568223e-01)/(-9.734131590357945e-03)));

%% Setup
p = 3;
d = 7;
nm = 6.3;

dim = 2; %problem dimension

m = nchoosek(p+dim, p); %number of polynomial terms;
n = round(nm*m);

% Nx = 20;
M = 100;

x_max = 4;
y_max = 2;

Kmul = 3;

%% Model
%%% HST
alpha = 0;
beta = 1;
gamma = 0;

fmod = @(x) 0.5*alpha*x.^2 + beta*x + gamma;

% %parset
T = 1;
r = 0.00;
kappa = 2.58;
eta = 0.043;
sig = 1;
rho = -0.36;

% S0 = [75,100,125];
% sig0 = 0.114;

K = 100;

%% Grid

x_min = 0;
% x_max = 20;
Kx = x_max/Kmul;
xscale = K*Kmul/x_max;
% Nx = 200
x = transpose(linspace(x_min,x_max,Nx));
dx = x(2)-x(1);


y_min = 0.001;
Ny = round(Nx*((y_max-y_min)/x_max));
y = transpose(linspace(y_min,y_max,Ny));
% y = y(2:end); Ny = Ny - 1;
dy = y(2)-y(1);

% y_min = 0.001;
% y_max = 4;
% Ny = round(Nx*((y_max-y_min)/x_max));
% c = y_max/1.5;
% i = 0:Ny;
% dyi = (1/Ny)*asinh(y_max/c);
% yi = i*dyi;
% y = c*sinh(yi);
% y = y(2:end);

[X,Y] = meshgrid(x,y);

xvec = X(:);
yvec = Y(:);

N = numel(xvec);

ind = 1:N;
indcf = 1:Ny;
% indcf = 1;
indff = (N-Ny+1):N; %, Ny:Ny:N-Ny];
indin = ind; 
indup = Ny:Ny:N;
inddo = 1:Ny:N;

% inddy0 = [indup, inddo];
inddy0 = indup(2:end-1);

indin([indff,indcf,inddy0]) = [];

%% Initial condition
u0 = max(xvec-Kx, 0);
u = u0;

%% RBF
phi='phs';
s = [xvec yvec];

parallel = 1;
xyscale = 1;
W = QLSVweights2Drbffd(r,rho,sig,alpha,beta,gamma,kappa,eta,xyscale,s,N,n,m,p,indin,inddy0,phi,d,'reg',parallel);
I = speye(size(W));

%% Integration
[u,xvec,yvec] = HSTeuCallintegrate(u,I,T,M,W,xscale,xvec,yvec,dx,dy,indin,indff,inddy0,Kx,r,'gmres');

%% Result

xres = [75,100,125];
yres = [0.114,0.114,0.114];

ures = griddata(xvec,yvec,u,xres,yres,'cubic');

end