function [ures] = SABReuCallIIK(K, T, r, alpha, beta, rho, S0, sig0, Nx, M, x_max, y_max, Kmul, p, d, n, m)
%% Grid
% Kmul = 2;

x_min = 0;
% x_max = 1;

Kx = x_max/Kmul;

xscale = K*Kmul/x_max;

y_min = 0.001;
% y_max = 1;

% Nx = 50;
Ny = round(Nx*((y_max-y_min)/x_max));

x = transpose(linspace(x_min,x_max,Nx));
y = transpose(linspace(y_min,y_max,Ny));

[X,Y] = meshgrid(x,y);

xvec = X(:);
yvec = Y(:);

N = numel(xvec);

ind = 1:N;
indcf = 1:Ny;
indff = (length(xvec)-Ny+1):(length(xvec));

indin = ind;

indup = Ny:Ny:N;
inddo = 1:Ny:N;

inddy0 = indup(2:end-1);

% indin([indff,indcf,inddy0]) = [];
indin([indff,indcf,inddy0]) = [];

% figure(1)
% clf
% plot(xvec,yvec,'.')
% hold on
% plot(xvec(inddy0-1),yvec(inddy0-1),'.')
% % plot(xvec(indff),yvec(indff),'sq')
% % plot(xvec(indcf),yvec(indcf),'^')
% % plot(xvec(indin),yvec(indin),'o')
% axis equal
% axis tight
% hold off

% M = 1000;

%% Initial condition
u0=max(xvec-Kx, 0);
u=u0;

% figure(2)
% tri = delaunay(xvec,yvec);
% trisurf(tri, xvec, yvec, u);
% shading interp
% colorbar
% view(2)
% axis vis3d
% % axis equal
% axis tight


%% RBF
% p = 5;
% d = 5;
% nm = 3;

phi='phs';

% n = round(nm*m)
s = [xvec yvec];

parallel = 1;
W = SABRweights2Drbffd(r,rho,alpha,beta,xscale,s,N,n,m,p,indin,phi,d,'reg',parallel);
I = speye(size(W));
% disp('Weights done!')

%% Integration
[u,xvec,yvec] = SABReuCallIIintegrate(u,I,T,M,W,xscale,xvec,yvec,indin,indff,inddy0,Kx,r,'gmres');

xres = S0;
yres = sig0;
ures = griddata(xvec,yvec,u,xres,yres,'cubic');

% figure(4)
% tri = delaunay(xvec,yvec);
% trisurf(tri, xvec, yvec, u);
% shading interp
% colorbar
% view(2)
% axis vis3d
% % axis equal
% axis tight
end

